const { byteHelper } = require('./bin/helpers');
const { DownloaderHelper } = require('./dist');
// const url = 'http://cdimage.deepin.com/releases/20.2.3/deepin-desktop-community-20.2.3-amd64.iso';
const url = 'https://proof.ovh.net/files/1Gb.dat';
const pkg = require('./package.json');
const options = {
    headers: {
        'user-agent': pkg.name + '@' + pkg.version
    },
    retry: { maxRetries: 3, delay: 3000 }
};

console.log('redirectedURL: ', new URL('https://proof.ovh.net', 'https://ovh.net').href);
console.log('redirectedURL: ', new URL('/files/v2', 'https://proof.ovh.net/').href);
console.log('regex[https://ovh.net]', /^https?:\/\//.test('https://ovh.net'));
console.log('regex[http://ovh.net]', /^https?:\/\//.test('http://ovh.net'));
console.log('regex[/files/v2]', /^https?:\/\//.test('/files/v2'));
process.exit();


/*
let startTime = new Date();
const dl = new DownloaderHelper(url, __dirname, options)
    .on('download', downloadInfo => console.log('Download Begins: ',
        {
            name: downloadInfo.fileName,
            total: downloadInfo.totalSize
        }))
    .on('end', downloadInfo => console.log('Download Completed: ', downloadInfo))
    .on('error', err => console.error('Error evt:', err))
    .on('timeout', () => console.log('TIMEOUT'))
    .on('retry', (attempt, opts, err) => {
        console.log({
            RetryAttempt: `${attempt}/${opts.maxRetries}`,
            StartsOn: `${opts.delay / 1000} secs`,
            Reason: err ? err.message : 'unknown'
        });
    })
    .on('stateChanged', state => console.log('State: ', state))
    .on('progress', stats => {
        const progress = stats.progress.toFixed(1);
        const speed = byteHelper(stats.speed);
        const downloaded = byteHelper(stats.downloaded);
        const total = byteHelper(stats.total);

        // print every one second (`progress.throttled` can be used instead)
        const currentTime = new Date();
        const elaspsedTime = currentTime - startTime;
        if (elaspsedTime > 1000) {
            startTime = currentTime;
            console.log(`${speed}/s - ${progress}% [${downloaded}/${total}]`);
        }
    });
console.log('Downloading: ', url);
dl.start()
    .then((...args) => console.log('ENDED', args))
    .catch(err => console.error('CATCH', err));

*/
// const fileUrl = 'https://ftp.nluug.nl/pub/graphics/blender/release/Blender2.93/blender-2.93.4-windows-x64.msi';
const fileUrl = 'https://www.learningcontainer.com/wp-content/uploads/2020/07/Sample-JPEG-Image-File-Download-scaled.jpg';

const dl = new DownloaderHelper(fileUrl, __dirname)

dl.on('end', (info) => console.log('Download Completed', info));
dl.on('progress', (stats) => console.log(stats));
dl.on('stateChanged', state => console.log('State: ', state));
dl.start();

setTimeout(() => {
    dl.pause();
    setTimeout(() => {
        dl.resume()
    }, 3000);
}, 1000);